#resource  "\\Images\\icon_pack_mql_gray_small.bmp"
#resource  "\\Images\\icon_pack_mql_small.bmp"
struct Element
  {
   string            name;
   string            text;

   long              chart_ID;
   int               index;
   int               type;
   int               sub_window;

   int               x;
   int               y;
   int               x_offset;
   int               y_offset;

   int               width;
   int               height;
   double            angle;

   datetime          time;
   double            price;

   ENUM_BASE_CORNER  corner;
   ENUM_ANCHOR_POINT anchor;

   string            font;
   int               font_size;

   int               border;
   int               style;
   int               line_width;

   color             clr;
   color             bg_clr;
   color             border_clr;

   bool              back;
   bool              selection;
   bool              hidden;

   long              z_order;

   int               state;
   int               prev_state;

   string            file;
   string            file_on;
   string            file_off;

   string            parent;
   string            children[144];

   int               event_id;
   long              lparam;
   double            dparam;
   string            sparam;

  };
Element defaultElement =
  {
   "UIElement",
   "Default Element",

   0,
   -1,
   32,
   0,

   10,
   10,
   0,
   0,

   0,
   0,
   0.0,

   0,
   0.0,

   CORNER_LEFT_UPPER,
   ANCHOR_LEFT_UPPER,

   "Arial",
   13,

   0,
   0,
   0,

   clrRed,
   clrWhite,
   clrBlack,

   false,
   false,
   false,

   0,

   0,
   0,

   "::Images\\icon_pack_mql_small.bmp",
   "::Images\\icon_pack_mql_gray_small.bmp",
   "::Images\\icon_pack_mql_small.bmp",

   "UIElement",
     {"UIElement"},

   0,
   0,
   0.0,
   ""
  };

Element elements[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
Element createElement( Element &elem, int type )
{
   Element e;
   e = elem;
   e.type = type;
   ENUM_OBJECT object_type;
   int d_width, d_height;
   string msg = "Object Type : ";
   // set default values
   if( e.chart_ID == NULL )e.chart_ID = 0;
   if( e.time == 0 )e.time = TimeCurrent();
   if( e.price == 0 )e.price = High[0];
   switch( e.type )
     {
      case 32 :
        msg = msg + "OBJ_TEXT";
        object_type = OBJ_TEXT;
        if( e.name == "UIElement" )e.name = e.name + "DefaultText";
        break;
      case 33 :
        msg = msg + "OBJ_LABEL";
        object_type = OBJ_LABEL;
        if( e.name == "UIElement" ){
         e.name = e.name + "DefaultLabel";
         e.text = "Default Label";
        }
        TextGetSize( e.text, d_width, d_height );
        if( e. width == 0 )e.width = d_width + 13;
        if( e.height == 0 )e.height = d_height + 13;
        break;
      case 34 :
        msg = msg + "OBJ_BUTTON";
        object_type = OBJ_BUTTON;
        if( e.name == "UIElement" ){
         e.name = e.name + "DefaultButton";
         e.text = "Default Button";
        }
        TextGetSize( e.text, d_width, d_height );
        if( e. width == 0 )e.width = d_width + 21;
        if( e.height == 0 )e.height = d_height + 21;
        break;
      case 35 :
        msg = msg + "OBJ_BITMAP";
        object_type = OBJ_BITMAP;
        if( e.name == "UIElement" ){
         e.name = e.name + "DefaultBitmap";
         e.text = "Default Bitmap";
        }
        if( e. width == 0 )e.width = 16;
        if( e.height == 0 )e.height = 16;
        break;
      case 36 :
        msg = msg + "OBJ_BITMAP_LABEL";
        object_type = OBJ_BITMAP_LABEL;
        if( e.name == "UIElement" ){
         e.name = e.name + "DefaultBitmapLabel";
         e.text = "Default Bitmap Label";
        };
        if( e. width == 0 )e.width = 16;
        if( e.height == 0 )e.height = 16;
        break;
      case 37 :
        msg = msg + "OBJ_EDIT";
        object_type = OBJ_EDIT;
        if( e.name == "UIElement" ){
         e.name = e.name + "DefaultEdit";
         e.text = "Default Edit";
        }
        TextGetSize( e.text, d_width, d_height );
        if( e. width == 0 )e.width = d_width + 13;
        if( e.height == 0 )e.height = d_height + 8;
        break;
      case 39 :
        msg = msg + "OBJ_RECTANGLE_LABEL";
        object_type = OBJ_RECTANGLE_LABEL;
        if( e.name == "UIElement" ){
         e.name = e.name + "DefaultRectangleLabel";
         e.text = "Default Rectangle Label";
        }
        if( e. width == 0 )e.width = 144;
        if( e.height == 0 )e.height = 55;
        break;
      default:
        object_type = OBJ_TEXT;
        msg = msg + "OBJ_TEXT";
        break;
     }
     //--- reset the error value
   ResetLastError();
//--- create object
   if(!ObjectCreate(e.chart_ID,e.name,object_type,e.sub_window,e.time,e.price))
     {
      Print(__FUNCTION__,
            ": failed to create \"Text\" object! Error code = ",GetLastError());
     }
//--- set the path to the image file
   ObjectSetString(e.chart_ID,e.name,OBJPROP_BMPFILE,e.file);
   ObjectSetString(e.chart_ID,e.name,OBJPROP_BMPFILE,0,e.file_on);
   ObjectSetString(e.chart_ID,e.name,OBJPROP_BMPFILE,1,e.file_off);
//--- set coordinates
   ObjectSetInteger(e.chart_ID,e.name,OBJPROP_XDISTANCE,e.x);
   ObjectSetInteger(e.chart_ID,e.name,OBJPROP_YDISTANCE,e.y);
//--- set size
   ObjectSetInteger(e.chart_ID,e.name,OBJPROP_XSIZE,e.width);
   ObjectSetInteger(e.chart_ID,e.name,OBJPROP_YSIZE,e.height);
//--- set the part of an image that is to be displayed in the visibility scope
//--- the default part is the upper left area of an image; the values allow
//--- performing a shift from this area displaying another part of the image
   ObjectSetInteger(e.chart_ID,e.name,OBJPROP_XOFFSET,e.x_offset);
   ObjectSetInteger(e.chart_ID,e.name,OBJPROP_YOFFSET,e.y_offset);
//--- define the label's status (pressed or released)
   ObjectSetInteger(e.chart_ID,e.name,OBJPROP_STATE,e.state);
//--- set the chart's corner, relative to which point coordinates are defined
   ObjectSetInteger(e.chart_ID,e.name,OBJPROP_CORNER,e.corner);
//--- set text
   ObjectSetString(e.chart_ID,e.name,OBJPROP_TEXT,e.text);
//--- set font
   ObjectSetString(e.chart_ID,e.name,OBJPROP_FONT,e.font);
//--- set font size
   ObjectSetInteger(e.chart_ID,e.name,OBJPROP_FONTSIZE,e.font_size);
//--- set the slope angle 
   ObjectSetDouble(e.chart_ID,e.name,OBJPROP_ANGLE,e.angle);
//--- set anchor type
   ObjectSetInteger(e.chart_ID,e.name,OBJPROP_ANCHOR,e.anchor);
//--- set border type
   ObjectSetInteger(e.chart_ID,e.name,OBJPROP_BORDER_TYPE,e.border);
//--- set color
   ObjectSetInteger(e.chart_ID,e.name,OBJPROP_COLOR,e.clr);
   ObjectSetInteger(e.chart_ID,e.name,OBJPROP_BGCOLOR,e.bg_clr);
//--- set border color
   ObjectSetInteger(e.chart_ID,e.name,OBJPROP_BORDER_COLOR,e.border_clr);
//--- set flat border line style
   ObjectSetInteger(e.chart_ID,e.name,OBJPROP_STYLE,e.style);
//--- set flat border width
   ObjectSetInteger(e.chart_ID,e.name,OBJPROP_WIDTH,e.line_width);
//--- display in the foreground (false) or background (true)
   ObjectSetInteger(e.chart_ID,e.name,OBJPROP_BACK,e.back);
//--- enable (true) or disable (false) the mode of moving the object by mouse
   ObjectSetInteger(e.chart_ID,e.name,OBJPROP_SELECTABLE,e.selection);
   ObjectSetInteger(e.chart_ID,e.name,OBJPROP_SELECTED,e.selection);
//--- hide (true) or display (false) graphical object name in the object list
   ObjectSetInteger(e.chart_ID,e.name,OBJPROP_HIDDEN,e.hidden);
//--- set the priority for receiving the event of a mouse click in the chart
   ObjectSetInteger(e.chart_ID,e.name,OBJPROP_ZORDER,e.z_order);
   return e;
};
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
Element getElement(string name, Element &array[])
{
   Element e;
   int total = ArraySize(array);
   for(int i=0; i<total; i++)
     {
      if(array[ i ].name == name)
        {
         e = array[ i ];
         e.index = i;
         break;
        }
     }
   return e;
};
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int modifyElement( Element &e, Element &array[] )
{
   int index = e.index; //index of the modified element
   Element x = getElement( e.name, array );
   if( x.name == e.name ) //check if element exists
   {
      e.index = x.index; //set index of the modified element
      array[ x.index ] = e;
      index = x.index;
      //--- set the path to the image file
      ObjectSetString(e.chart_ID,e.name,OBJPROP_BMPFILE,e.file);
      ObjectSetString(e.chart_ID,e.name,OBJPROP_BMPFILE,0,e.file_on);
      ObjectSetString(e.chart_ID,e.name,OBJPROP_BMPFILE,1,e.file_off);
   //--- set coordinates
      ObjectSetInteger(e.chart_ID,e.name,OBJPROP_XDISTANCE,e.x);
      ObjectSetInteger(e.chart_ID,e.name,OBJPROP_YDISTANCE,e.y);
   //--- set size
      ObjectSetInteger(e.chart_ID,e.name,OBJPROP_XSIZE,e.width);
      ObjectSetInteger(e.chart_ID,e.name,OBJPROP_YSIZE,e.height);
   //--- set the part of an image that is to be displayed in the visibility scope
   //--- the default part is the upper left area of an image; the values allow
   //--- performing a shift from this area displaying another part of the image
      ObjectSetInteger(e.chart_ID,e.name,OBJPROP_XOFFSET,e.x_offset);
      ObjectSetInteger(e.chart_ID,e.name,OBJPROP_YOFFSET,e.y_offset);
   //--- define the label's status (pressed or released)
      ObjectSetInteger(e.chart_ID,e.name,OBJPROP_STATE,e.state);
   //--- set the chart's corner, relative to which point coordinates are defined
      ObjectSetInteger(e.chart_ID,e.name,OBJPROP_CORNER,e.corner);
   //--- set text
      ObjectSetString(e.chart_ID,e.name,OBJPROP_TEXT,e.text);
   //--- set font
      ObjectSetString(e.chart_ID,e.name,OBJPROP_FONT,e.font);
   //--- set font size
      ObjectSetInteger(e.chart_ID,e.name,OBJPROP_FONTSIZE,e.font_size);
   //--- set the slope angle 
      ObjectSetDouble(e.chart_ID,e.name,OBJPROP_ANGLE,e.angle);
   //--- set anchor type
      ObjectSetInteger(e.chart_ID,e.name,OBJPROP_ANCHOR,e.anchor);
   //--- set border type
      ObjectSetInteger(e.chart_ID,e.name,OBJPROP_BORDER_TYPE,e.border);
   //--- set color
      ObjectSetInteger(e.chart_ID,e.name,OBJPROP_COLOR,e.clr);
      ObjectSetInteger(e.chart_ID,e.name,OBJPROP_BGCOLOR,e.bg_clr);
   //--- set border color
      ObjectSetInteger(e.chart_ID,e.name,OBJPROP_BORDER_COLOR,e.border_clr);
   //--- set flat border line style
      ObjectSetInteger(e.chart_ID,e.name,OBJPROP_STYLE,e.style);
   //--- set flat border width
      ObjectSetInteger(e.chart_ID,e.name,OBJPROP_WIDTH,e.line_width);
   //--- display in the foreground (false) or background (true)
      ObjectSetInteger(e.chart_ID,e.name,OBJPROP_BACK,e.back);
   //--- enable (true) or disable (false) the mode of moving the object by mouse
      ObjectSetInteger(e.chart_ID,e.name,OBJPROP_SELECTABLE,e.selection);
      ObjectSetInteger(e.chart_ID,e.name,OBJPROP_SELECTED,e.selection);
   //--- hide (true) or display (false) graphical object name in the object list
      ObjectSetInteger(e.chart_ID,e.name,OBJPROP_HIDDEN,e.hidden);
   //--- set the priority for receiving the event of a mouse click in the chart
      ObjectSetInteger(e.chart_ID,e.name,OBJPROP_ZORDER,e.z_order);
   }
   return index; //return index of the modified element
};
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
Element addElement(Element &e, Element &array[])
{
   int index = -1; //index of the added element
   int total  = ArraySize( array ); //get total elements
   int newTotal = total + 1; //increment total by 1
   ArrayResize( array, newTotal, 0 ); //increase size of array by 1
   array[ total ] = e; //add the element to the last index of the array
   return e; //return index of the added element
};
